import json
import logging
from p2_store.postgresInt import SQLit


class Experiment:

    def __init__(self):
        self.sqlit = SQLit()
        self.log = logging.getLogger(__name__)

    def deleteExperiment(self, filename):    
        QUERY = "DELETE FROM experiments WHERE filename=%s;"
        return self.sqlit.execute(QUERY, (filename,))

    def getExperiments(self):
        QUERY = "SELECT filename FROM experiments ORDER BY filename ASC;"
        return (self.sqlit.execute(QUERY))
        
    def getExperiment(self, filename):
        QUERY = "SELECT data FROM experiments WHERE filename = %s;"
        return (self.sqlit.execute(QUERY, (filename,))[0][0])

    def postExperiment(self, filename, data):    
        self.log.debug("Create experiment {}".format(filename))
        self.log.debug("Data: {}".format(data))
        QUERY = "INSERT INTO experiments (filename, data) VALUES (%s, %s);"
        return self.sqlit.execute(QUERY, filename, json.dumps(data))
        
    def updateExperiment(self, filename, data):    
        return self.sqlit.update('experiments', 'filename', filename, {'data':
            json.dumps(data)})
