from p2_store.postgresInt import SQLit

class K8sResource:

    def __init__(self):
        self.sqlit = SQLit()

    def add_resource( self, resource ):
        stmt = self.sqlit.insert_stmt('k8s_resources', resource)
        return self.sqlit.execute(stmt, resource)

    def get_resources(self, filter, size=1000, offset=0):
        return self.sqlit.select_as_dict('k8s_resources', filter, size, offset)


    def get_resources_of_kind( self, kind, size=1000, offset=0 ):
        count = size

        if not offset:
            sql = "SELECT count(*) from k8s_resources where kind = %s;"
            recs = self.sqlit.execute(sql, (kind,))
            count = recs[0][0]

        cmd = """
            SELECT * FROM k8s_resources 
                WHERE kind = %s
                ORDER BY name DESC
                LIMIT %s
                OFFSET %s
            """
        return {
                "count": count,
                "records": self.sqlit.execute(cmd, kind, size, offset)
        }


    def get_children( self, parent_id ):
        pass


